<template>
  <div class="flex flex-col">
    <a-input label="Name:" placeholder="name" :validators="nameValidators"
      v-model="lodge.name" />
    <a-input label="Country:" placeholder="country" :validators="letterNamesValidators"
      v-model="lodge.country" />
    <div class="flex justify-center">
      <SubmitButton value="post" @click="submit" />
      <CancelButton value="cancel" @click="cancel" />
    </div>
  </div>
</template>

<script>
import { useRoute } from 'vue-router';
import { mapGetters } from 'vuex';
import AInput from '@/components/AInput.vue';
import Selector from '@/components/Selector.vue';
import SubmitButton from '@/components/SubmitButton.vue';
import CancelButton from '@/components/CancelButton.vue'
import { emptyValidator, letterNamesValidator, nameValidator } from '@/components/Validators.js'
import axiosClient from '@/axiosClient';

export default {
  components: {
    AInput,
    Selector,
    SubmitButton,
    CancelButton
  },
  data() {
    return {
      lodge: {},
      nameValidators: [nameValidator],
      letterNamesValidators: [letterNamesValidator],
      professionValidators: [emptyValidator],
      new: false
    }
  },
  methods: {
    submit() {
      if (this.new) {
        this.create()
      } else {
        this.update()
      }
    },
    create() {
      const payload = JSON.stringify({
        data: {
          attributes: {
            name: this.lodge.name,
            country: this.lodge.country,
          }
        }
      })

      axiosClient.post('/lodges', payload)
        .then(() => {
          this.$router.go(-1)
        })
    },
    update() {
      const payload = JSON.stringify({
        data: {
          attributes: {
            new_name: this.lodge.name,
            new_country: this.lodge.country,
          }
        }
      })

      axiosClient.patch(`/lodges/${this.lodge.id}`, payload)
        .then(() => {
          this.$router.go(-1)
        })
    },
    cancel() {
      this.$router.go(-1)
    }
  },
  computed: {
    ...mapGetters({
      lodgeById: "getLodge",
      lodges: "getLodges",
    })
  },
  created() {
    if (useRoute().params.id != 'new') {
      Object.assign(this.lodge = this.lodgeById(useRoute().params.id))
    } else {
      this.lodge.grand_master = 1,
        this.new = true
    }
  }
}

</script>